Index: trunk/NEMO/TOP_SRC/TRP/trcrad.F90
===================================================================
--- trunk/NEMO/TOP_SRC/TRP/trcrad.F90	(revision 1118)
+++ trunk/NEMO/TOP_SRC/TRP/trcrad.F90	(revision 1119)
@@ -14,5 +14,5 @@
    !!----------------------------------------------------------------------
    USE oce_trc             ! ocean dynamics and tracers variables
-   USE trc                 ! ocean passive tracers variables
+   USE trp_trc                 ! ocean passive tracers variables
    USE lib_mpp
    USE prtctl_trc          ! Print control for debbuging
Index: trunk/NEMO/TOP_SRC/TRP/trcsbc.F90
===================================================================
--- trunk/NEMO/TOP_SRC/TRP/trcsbc.F90	(revision 1118)
+++ trunk/NEMO/TOP_SRC/TRP/trcsbc.F90	(revision 1119)
@@ -12,5 +12,5 @@
    !! * Modules used
    USE oce_trc             ! ocean dynamics and active tracers variables
-   USE trc                 ! ocean  passive tracers variables
+   USE trp_trc                 ! ocean  passive tracers variables
    USE prtctl_trc          ! Print control for debbuging
 
Index: trunk/NEMO/TOP_SRC/TRP/trcstp.F90
===================================================================
--- trunk/NEMO/TOP_SRC/TRP/trcstp.F90	(revision 1118)
+++ trunk/NEMO/TOP_SRC/TRP/trcstp.F90	(revision 1119)
@@ -10,5 +10,5 @@
    !! * Modules used
    USE oce_trc          ! ocean dynamics and active tracers variables
-   USE trc              ! ocean passive tracers variables 
+   USE trp_trc
    USE trctrp           ! passive tracers transport
    USE trcsms           ! passive tracers sources and sinks
Index: trunk/NEMO/TOP_SRC/TRP/trctrp.F90
===================================================================
--- trunk/NEMO/TOP_SRC/TRP/trctrp.F90	(revision 1118)
+++ trunk/NEMO/TOP_SRC/TRP/trctrp.F90	(revision 1119)
@@ -13,5 +13,5 @@
    !!----------------------------------------------------------------------
    USE oce_trc         ! ocean dynamics and active tracers variables
-   USE trc             ! ocean passive tracers variables 
+   USE trp_trc             ! ocean passive tracers variables 
    USE trctrp_lec      ! passive tracers transport parameters
    USE prtctl_trc     ! Print control for debbuging
Index: trunk/NEMO/TOP_SRC/TRP/trctrp_ctl.F90
===================================================================
--- trunk/NEMO/TOP_SRC/TRP/trctrp_ctl.F90	(revision 1118)
+++ trunk/NEMO/TOP_SRC/TRP/trctrp_ctl.F90	(revision 1119)
@@ -17,5 +17,5 @@
    !!----------------------------------------------------------------------
    USE oce_trc       ! ocean dynamics and active tracers variables
-   USE trc           ! ocean passive tracers variables
+   USE trp_trc           ! ocean passive tracers variables
    USE trctrp_lec    ! passive tracers transport
 
Index: trunk/NEMO/TOP_SRC/TRP/trctrp_lec.F90
===================================================================
--- trunk/NEMO/TOP_SRC/TRP/trctrp_lec.F90	(revision 1118)
+++ trunk/NEMO/TOP_SRC/TRP/trctrp_lec.F90	(revision 1119)
@@ -14,5 +14,5 @@
    !!----------------------------------------------------------------------
    USE oce_trc             ! ocean dynamics and active tracers variables
-   USE trc                 ! ocean passive tracers variables
+   USE trp_trc                 ! ocean passive tracers variables
 
    IMPLICIT NONE
@@ -68,4 +68,8 @@
    REAL(wp) , PUBLIC ::   hdmptr   =  800.            !: depth of transition between sdmp and bdmp (meters)
 #endif
+   !                                                 !!: ** SMOLAR advection scheme
+   REAL(wp) , PUBLIC ::  rsc       = 1.               !: tuning coefficient for anti-diffusion
+   INTEGER  , PUBLIC ::  ncortrc   = 1                !: number of corrective phases
+   LOGICAL  , PUBLIC ::  crosster  = .FALSE.          !: computes crossterms (T) or not (F)
    !!----------------------------------------------------------------------
    !! NEMO/TOP 2.0 , LOCEAN-IPSL (2007) 
@@ -82,15 +86,16 @@
       !! ** Purpose :   Read Namelist for tracer transport option
       !!----------------------------------------------------------------------
-      NAMELIST/namtrcadv/ ln_trcadv_cen2 , ln_trcadv_tvd,   &
-         &                 ln_trcadv_muscl, ln_trcadv_muscl2, ln_trcadv_smolar
+      NAMELIST/namtopadv/ ln_trcadv_cen2 , ln_trcadv_tvd,   &
+         &                ln_trcadv_muscl, ln_trcadv_muscl2, ln_trcadv_smolar, &
+         &                rsc, ncortrc, crosster
 #if  defined key_trcbbl_dif   ||   defined key_trcbbl_adv 
-      NAMELIST/namtrcbbl/ atrcbbl
-#endif
-      NAMELIST/namtrcldf/  ln_trcldf_diff  , ln_trcldf_lap  , ln_trcldf_bilap, &
+      NAMELIST/namtopbbl/ atrcbbl
+#endif
+      NAMELIST/namtopldf/  ln_trcldf_diff  , ln_trcldf_lap  , ln_trcldf_bilap, &
          &                 ln_trcldf_level, ln_trcldf_hor, ln_trcldf_iso,   &
          &                 ahtrc0, ahtrb0, aeivtr0, trcrat
-      NAMELIST/namtrczdf/ ln_trczdf_exp, n_trczdf_exp
+      NAMELIST/namtopzdf/ ln_trczdf_exp, n_trczdf_exp
 #if defined key_trcdmp
-      NAMELIST/namtrcdmp/ ndmptr, ndmpftr, nmldmptr, sdmptr, bdmptr, hdmptr
+      NAMELIST/namtopdmp/ ndmptr, ndmpftr, nmldmptr, sdmptr, bdmptr, hdmptr
 #endif
       !!----------------------------------------------------------------------
@@ -101,25 +106,30 @@
 
       !                                ! tracer advection scheme
-      REWIND( numnat )                 !   ! Read Namelist namtrcadv
-      READ  ( numnat, namtrcadv )
-
-      IF(lwp) THEN                     !   ! Control print
-         WRITE(numout,*)
-         WRITE(numout,*) '   Namelist namtrcadv : chose a advection scheme for tracers'
-         WRITE(numout,*) '      2nd order advection scheme     ln_trcadv_cen2   = ', ln_trcadv_cen2
-         WRITE(numout,*) '      TVD advection scheme           ln_trcadv_tvd    = ', ln_trcadv_tvd
-         WRITE(numout,*) '      MUSCL  advection scheme        ln_trcadv_muscl  = ', ln_trcadv_muscl
-         WRITE(numout,*) '      MUSCL2 advection scheme        ln_trcadv_muscl2 = ', ln_trcadv_muscl2
-         WRITE(numout,*) '      SMOLARKIEWICZ advection scheme ln_trcadv_smolar = ', ln_trcadv_smolar
+      REWIND( numnat )                 !   ! Read Namelist namtopadv
+      READ  ( numnat, namtopadv )
+
+      IF(lwp) THEN                     !   ! Control print
+         WRITE(numout,*)
+         WRITE(numout,*) '   Namelist namtopadv : chose a advection scheme for tracers'
+         WRITE(numout,*) '      2nd order advection scheme               ln_trcadv_cen2   = ', ln_trcadv_cen2
+         WRITE(numout,*) '      TVD advection scheme                     ln_trcadv_tvd    = ', ln_trcadv_tvd
+         WRITE(numout,*) '      MUSCL  advection scheme                  ln_trcadv_muscl  = ', ln_trcadv_muscl
+         WRITE(numout,*) '      MUSCL2 advection scheme                  ln_trcadv_muscl2 = ', ln_trcadv_muscl2
+         WRITE(numout,*) '      SMOLARKIEWICZ advection scheme           ln_trcadv_smolar = ', ln_trcadv_smolar
+         IF( ln_trcadv_smolar ) THEN
+            WRITE(numout,*) '      SMOLARKIEWICZ : tuning coefficient                rsc      = ', rsc
+            WRITE(numout,*) '      SMOLARKIEWICZ : number of corrective phase        ncortrc  = ', ncortrc
+            WRITE(numout,*) '      SMOLARKIEWICZ : computes or not crossterms        crosster = ', crosster
+         ENDIF
       ENDIF
 
 #if  defined key_trcbbl_dif
       !                                ! Bottom boundary layer 
-      REWIND( numnat )                 !   ! Read Namelist namtrcbbl
-      READ  ( numnat, namtrcbbl )
-
-      IF(lwp) THEN                     !   ! Control print
-         WRITE(numout,*)
-         WRITE(numout,*) '   Namelist namtrcbbl : set Diffusive Bottom Boundary Layer parameters'
+      REWIND( numnat )                 !   ! Read Namelist namtopbbl
+      READ  ( numnat, namtopbbl )
+
+      IF(lwp) THEN                     !   ! Control print
+         WRITE(numout,*)
+         WRITE(numout,*) '   Namelist namtopbbl : set Diffusive Bottom Boundary Layer parameters'
          WRITE(numout,*) '      bottom boundary layer coef.    atrcbbl = ', atrcbbl
 # if defined key_trcbbl_adv
@@ -130,10 +140,10 @@
 
       !                                ! Lateral physics on tracers   
-      REWIND( numnat )                 !   ! Read Namelist namtrcldf
-      READ  ( numnat, namtrcldf )
-
-      IF(lwp) THEN                     !   ! Control print
-         WRITE(numout,*)
-         WRITE(numout,*) '   Namelist namtrcldf : set lateral mixing parameters (type, direction, coefficients)'
+      REWIND( numnat )                 !   ! Read Namelist namtopldf
+      READ  ( numnat, namtopldf )
+
+      IF(lwp) THEN                     !   ! Control print
+         WRITE(numout,*)
+         WRITE(numout,*) '   Namelist namtopldf : set lateral mixing parameters (type, direction, coefficients)'
          WRITE(numout,*) '      perform lateral diffusion or not               ln_trcldf_diff  = ', ln_trcldf_diff
          WRITE(numout,*) '      laplacian operator                             ln_trcldf_lap   = ', ln_trcldf_lap
@@ -149,10 +159,10 @@
 
       !                                ! Vertical mixing
-      REWIND( numnat )                 !   ! Read namtrczdf namelist
-      READ  ( numnat, namtrczdf )
-
-      IF(lwp) THEN                     !   ! Control print
-         WRITE(numout,*)
-         WRITE(numout,*) '   Namelist namtrczdf : set vertical diffusion parameters'
+      REWIND( numnat )                 !   ! Read namtopzdf namelist
+      READ  ( numnat, namtopzdf )
+
+      IF(lwp) THEN                     !   ! Control print
+         WRITE(numout,*)
+         WRITE(numout,*) '   Namelist namtopzdf : set vertical diffusion parameters'
          WRITE(numout,*) '      time splitting / backward scheme ln_trczdf_exp = ', ln_trczdf_exp
          WRITE(numout,*) '      number of time step               n_trczdf_exp = ', n_trczdf_exp
@@ -162,10 +172,10 @@
       !                                ! passive tracres damping term
       REWIND( numnat )                 !   ! Read Namelist namtdp
-      READ  ( numnat, namtrcdmp )
+      READ  ( numnat, namtopdmp )
       IF( lzoom )   nmldmptr = 0           ! restoring to climatology at closed north or south boundaries
 
       IF(lwp) THEN                     !   ! Control print
          WRITE(numout,*)
-         WRITE(numout,*) '   Namelist namtrcdmp : set damping parameter'
+         WRITE(numout,*) '   Namelist namtopdmp : set damping parameter'
          WRITE(numout,*) '      tracers damping option         ndmptr   = ', ndmptr
          WRITE(numout,*) '      create a damping.coeff file    ndmpftr  = ', ndmpftr
Index: trunk/NEMO/TOP_SRC/TRP/trczdf_exp.F90
===================================================================
--- trunk/NEMO/TOP_SRC/TRP/trczdf_exp.F90	(revision 1118)
+++ trunk/NEMO/TOP_SRC/TRP/trczdf_exp.F90	(revision 1119)
@@ -14,5 +14,5 @@
    !! * Modules used
    USE oce_trc          ! ocean dynamics and active tracers variables
-   USE trc              ! ocean passive tracers variables
+   USE trp_trc              ! ocean passive tracers variables
    USE trctrp_lec       ! passive tracers transport
    USE prtctl_trc          ! Print control for debbuging
Index: trunk/NEMO/TOP_SRC/TRP/trczdf_imp.F90
===================================================================
--- trunk/NEMO/TOP_SRC/TRP/trczdf_imp.F90	(revision 1118)
+++ trunk/NEMO/TOP_SRC/TRP/trczdf_imp.F90	(revision 1119)
@@ -13,5 +13,5 @@
    !! * Modules used
    USE oce_trc             ! ocean dynamics and active tracers variables
-   USE trc                 ! ocean passive tracers variables
+   USE trp_trc                 ! ocean passive tracers variables
    USE trctrp_lec          ! passive tracers transport
    USE prtctl_trc
Index: trunk/NEMO/TOP_SRC/TRP/trczdf_iso.F90
===================================================================
--- trunk/NEMO/TOP_SRC/TRP/trczdf_iso.F90	(revision 1118)
+++ trunk/NEMO/TOP_SRC/TRP/trczdf_iso.F90	(revision 1119)
@@ -15,5 +15,5 @@
    !! * Modules used
    USE oce_trc          ! ocean dynamics and tracers variables
-   USE trc              ! ocean passive tracers variables 
+   USE trp_trc              ! ocean passive tracers variables 
    USE lbclnk           ! ocean lateral boundary conditions (or mpp link)
    USE trctrp_lec       ! passive tracers transport
Index: trunk/NEMO/TOP_SRC/TRP/trczdf_iso_vopt.F90
===================================================================
--- trunk/NEMO/TOP_SRC/TRP/trczdf_iso_vopt.F90	(revision 1118)
+++ trunk/NEMO/TOP_SRC/TRP/trczdf_iso_vopt.F90	(revision 1119)
@@ -18,5 +18,5 @@
    !! * Modules used
    USE oce_trc         ! ocean dynamics and tracers variables
-   USE trc             ! ocean passive tracers variables 
+   USE trp_trc             ! ocean passive tracers variables 
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
    USE trctrp_lec      ! passive tracers transport
Index: trunk/NEMO/TOP_SRC/TRP/zpshde_trc.F90
===================================================================
--- trunk/NEMO/TOP_SRC/TRP/zpshde_trc.F90	(revision 1118)
+++ trunk/NEMO/TOP_SRC/TRP/zpshde_trc.F90	(revision 1119)
@@ -15,5 +15,5 @@
    !! * Modules used
    USE oce_trc         ! ocean dynamics and tracers variables
-   USE trc             ! ocean passive tracers variables
+   USE trp_trc             ! ocean passive tracers variables
    USE lbclnk          ! lateral boundary conditions (or mpp link)
 
Index: trunk/NEMO/TOP_SRC/oce_trc.F90
===================================================================
--- trunk/NEMO/TOP_SRC/oce_trc.F90	(revision 1118)
+++ trunk/NEMO/TOP_SRC/oce_trc.F90	(revision 1119)
@@ -202,6 +202,4 @@
    !* vertical diffusion *
    USE zdf_oce , ONLY :   avt        =>   avt         !: vert. diffusivity coef. at w-point for temp  
-   USE zdf_oce , ONLY :   avt0       =>   avt0        !: vertical eddy diffusivity for tracers (m2/s)
-   USE zdf_oce , ONLY :   ln_zdfnpc  =>   ln_zdfnpc   !: convection: non-penetrative convection flag
 # if defined key_zdfddm
    USE zdfddm  , ONLY :   avs        =>    avs        !: salinity vertical diffusivity coeff. at w-point
Index: trunk/NEMO/TOP_SRC/par_trc.F90
===================================================================
--- trunk/NEMO/TOP_SRC/par_trc.F90	(revision 1118)
+++ trunk/NEMO/TOP_SRC/par_trc.F90	(revision 1119)
@@ -30,5 +30,5 @@
    INTEGER, PUBLIC, PARAMETER ::   jpdia3d  =  jp_lobster_3d + jp_pisces_3d  + jp_cfc_3d  + jp_my_trc_3d
    !                     ! total number of sms diagnostic arrays
-   INTEGER, PUBLIC, PARAMETER ::   jpdiatrd = jp_lobster_trd + jp_pisces_trd + jp_cfc_trd + jp_my_trc_trd
+   INTEGER, PUBLIC, PARAMETER ::   jpdiabio = jp_lobster_trd + jp_pisces_trd + jp_cfc_trd + jp_my_trc_trd
    
    !  1D configuration ("key_c1d")
@@ -55,4 +55,5 @@
 #endif
 
+   REAL(wp), PUBLIC  :: rtrn  = 1.e-15      !: truncation value     
    !!======================================================================
 END MODULE par_trc
Index: trunk/NEMO/TOP_SRC/trc.F90
===================================================================
--- trunk/NEMO/TOP_SRC/trc.F90	(revision 1118)
+++ trunk/NEMO/TOP_SRC/trc.F90	(revision 1119)
@@ -46,47 +46,13 @@
    REAL(wp), PUBLIC, DIMENSION (jpi,jpj,jpk,jptra) ::   trb   !: traceur concentration for before time step
 
-
-   !! numerical parameter (NAMELIST)
-   !! --------------------------------------------------
-   REAL(wp), PUBLIC ::   rsc    !: tuning coefficient for anti-diffusion
-   REAL(wp), PUBLIC ::   rtrn   !: value for truncation
-
-   !! namelist parameters
-   !! --------------------------------------------------
-   INTEGER , PUBLIC ::   ncortrc     !: number of corrective phases
-   INTEGER , PUBLIC ::   ndttrc      !: frequency of step on passive tracers
-   INTEGER , PUBLIC ::   nittrc000   !: first time step of passive tracers model  
-   LOGICAL , PUBLIC ::   crosster    !: logical if true computes crossterms
-
-
-   !! isopycnal scheme for passive tracers
-   !! ------------------------------------  
-   REAL(wp), PUBLIC ::   ahtrb0     !: background diffusivity coefficient for passive tracer (m2/s)
-   REAL(wp), PUBLIC ::   trcrat     !: ratio between passive and active tracer coeff for diffusion
-   REAL(wp), PUBLIC ::   ahtrc0     !: horizontal eddy diffusivity for passive tracers (m2/s)
-   REAL(wp), PUBLIC ::   aeivtr0    !: eddy induced velocity coefficient (m2/s)
-   
    
    !! passive tracers restart (input and output)
    !! ------------------------------------------  
+   INTEGER , PUBLIC ::   ndttrc     !: frequency of step on passive tracers
+   INTEGER , PUBLIC ::   nittrc000  !: first time step of passive tracers model
    LOGICAL , PUBLIC ::   lrsttr     !: boolean term for restart i/o for passive tracers (namelist)
    INTEGER , PUBLIC ::   nutwrs     !: output FILE for passive tracers restart
    INTEGER , PUBLIC ::   nutrst     !: logical unit for restart FILE for passive tracers
    INTEGER , PUBLIC ::   nrsttr     !: control of the time step ( 0 or 1 ) for pass. tr.
-   
-   
-   !! interpolated gradient
-   !!--------------------------------------------------  
-   REAL(wp), PUBLIC, DIMENSION (jpi,jpj,jptra) ::   gtru   !: horizontal gradient at u-points at bottom ocean level
-   REAL(wp), PUBLIC, DIMENSION (jpi,jpj,jptra) ::   gtrv   !: horizontal gradient at v-points at bottom ocean level
-
-   
-# if defined key_trcldf_eiv && defined key_diaeiv
-   !! The three component of the eddy induced velocity
-   !! --------------------------------------------------
-   REAL(wp), PUBLIC, DIMENSION (jpi,jpj,jpk) ::   u_trc_eiv   !: u-eiv (m/s)
-   REAL(wp), PUBLIC, DIMENSION (jpi,jpj,jpk) ::   v_trc_eiv   !: v-eiv (m/s)
-   REAL(wp), PUBLIC, DIMENSION (jpi,jpj,jpk) ::   w_trc_eiv   !: w-eiv (m/s)
-# endif
    
    
@@ -114,24 +80,4 @@
    INTEGER , PUBLIC ::   nwritedia     !: frequency of additional arrays outputs(namelist)
 # endif
-   
-# if defined key_trc_diatrd
-   
-   !!  non conservative trends (biological, ...)
-   !! --------------------------------------------------
-   LOGICAL, PUBLIC, DIMENSION (jptra) ::   luttrd   !: large trends diagnostic to write or not (namelist)
-   
-   !!  Advection-diffusion trends
-   !! --------------------------------------------------
-   REAL(wp), PUBLIC, DIMENSION(:,:,:,:,:), ALLOCATABLE ::   trtrd   !: trends of the tracer equations
-   
-   INTEGER, PUBLIC, DIMENSION(jptra) :: ikeep ! indice of tracer for which dyn trends are stored
-   INTEGER, PUBLIC                   :: nkeep ! number of tracers for which dyn trends are stored 
-   !                                          ! (used to allocate trtrd buffer)
-
-   !! netcdf files and index common
-   !! --------------------------------------------------
-   INTEGER , PUBLIC ::   nwritetrd   !: frequency of additional arrays outputs(namelist)
-   
-# endif 
 
 # if defined key_trc_diabio
Index: trunk/NEMO/TOP_SRC/trcctl.F90
===================================================================
--- trunk/NEMO/TOP_SRC/trcctl.F90	(revision 1118)
+++ trunk/NEMO/TOP_SRC/trcctl.F90	(revision 1119)
@@ -65,15 +65,4 @@
       ENDIF
 
-      ! Don't USE non penetrative convective mixing option
-      ! it's not implemented for passive tracer
-      IF( ln_zdfnpc ) THEN
-         IF(lwp) WRITE (numout,*) ' ===>>>> : w a r n i n g '
-         IF(lwp) WRITE (numout,*) ' =======   ============= '
-         IF(lwp) WRITE (numout,*) ' STOP, this sheme is not implemented'
-         IF(lwp) WRITE (numout,*) ' in passive tracer model:'
-         IF(lwp) WRITE (numout,*) ' non penetrative convect. mixing scheme'
-         istop = istop + 1
-      ENDIF
-
       ! transport scheme option
       CALL trc_trp_ctl
Index: trunk/NEMO/TOP_SRC/trcdia.F90
===================================================================
--- trunk/NEMO/TOP_SRC/trcdia.F90	(revision 1118)
+++ trunk/NEMO/TOP_SRC/trcdia.F90	(revision 1119)
@@ -23,4 +23,5 @@
    USE oce_trc
    USE trc
+   USE trp_trc
    USE dianam    ! build name of file (routine)
    USE in_out_manager  ! I/O manager
@@ -77,12 +78,6 @@
       
       CALL trcdit_wr( kt, kindic )      ! outputs for tracer concentration
-      
-
       CALL trcdid_wr( kt, kindic )      ! outputs for dynamical trends
-
-      
       CALL trcdii_wr( kt, kindic )      ! outputs for additional arrays
-
-      
       CALL trcdib_wr( kt, kindic )      ! outputs for biological trends
 
@@ -437,6 +432,5 @@
                IF( jl == jpdiatrc )   WRITE (cltra,'("SBC_",a)') ctrcnm(jn)      ! surface boundary conditions
                !
-               CALL histwrite(nit6(jn), cltra, it, trtrd(:,:,:,ikeep(jn),jl)   &
-                  &          ,ndimt50, ndext50)
+               CALL histwrite(nit6(jn), cltra, it, trtrd(:,:,:,ikeep(jn),jl),ndimt50, ndext50)
             END DO
          END IF
@@ -562,7 +556,7 @@
          ! more 2D horizontal arrays
          DO jn = 1, jpdia2d
-            cltra=ctrc2d(jn)    ! short title for 2D diagnostic
-            cltral=ctrc2l(jn)   ! long title for 2D diagnostic
-            cltrau=ctrc2u(jn)   ! UNIT for 2D diagnostic
+            cltra  = ctrc2d(jn)    ! short title for 2D diagnostic
+            cltral = ctrc2l(jn)   ! long title for 2D diagnostic
+            cltrau = ctrc2u(jn)   ! UNIT for 2D diagnostic
             CALL histdef( nitd, cltra, cltral, cltrau, jpi, jpj, nhoritd,  &
                &          1, 1, 1,  -99, 32, clop, zsto, zout )
@@ -591,6 +585,5 @@
       DO jn = 1, jpdia3d
          cltra = ctrc3d(jn)   ! short title for 3D diagnostic
-         CALL histwrite( nitd, cltra, it, trc3d(:,:,:,jn), ndimt50  &
-            &           ,ndext50)
+         CALL histwrite( nitd, cltra, it, trc3d(:,:,:,jn), ndimt50 ,ndext50)
       END DO
 
@@ -598,6 +591,5 @@
       DO jn = 1, jpdia2d
          cltra = ctrc2d(jn)   ! short title for 2D diagnostic
-         CALL histwrite(nitd, cltra, it, trc2d(:,:,jn), ndimt51    &
-            &   ,ndext51)
+         CALL histwrite(nitd, cltra, it, trc2d(:,:,jn), ndimt51  ,ndext51)
       END DO
 
Index: trunk/NEMO/TOP_SRC/trclec.F90
===================================================================
--- trunk/NEMO/TOP_SRC/trclec.F90	(revision 1118)
+++ trunk/NEMO/TOP_SRC/trclec.F90	(revision 1119)
@@ -20,4 +20,5 @@
    USE oce_trc
    USE trc
+   USE trp_trc
    USE trctrp_lec
    USE trclsm_lobster    ! LOBSTER namelist
@@ -66,25 +67,10 @@
       TYPE(PTRACER) , DIMENSION(jptra) :: tracer
 
-#if defined key_trc_diaadd
-      ! definition of additional diagnostic as a structure
-      TYPE DIAG
-         CHARACTER(len = 20)  :: snamedia   !: short name
-         CHARACTER(len = 80 ) :: lnamedia   !: long name
-         CHARACTER(len = 20 ) :: unitdia    !: unit
-      END TYPE DIAG
-
-      TYPE(DIAG) , DIMENSION(jpdia2d) :: diag2d
-      TYPE(DIAG) , DIMENSION(jpdia3d) :: diag3d
+      !!
+      NAMELIST/namtoptrc/ ndttrc, nwritetrc, lrsttr, nrsttr, tracer
+#if defined key_trc_diatrd
+      NAMELIST/namtoptrd/ luttrd, nwritetrd                                             ! dynamical trends
 #endif
 
-      !!
-      NAMELIST/nattrc/ nwritetrc, lrsttr, nrsttr, tracer
-      NAMELIST/natnum/ rsc, rtrn, ncortrc, ndttrc, crosster
-#if defined key_trc_diatrd
-      NAMELIST/natrtd/ luttrd, nwritetrd                                             ! dynamical trends
-#endif
-#if defined key_trc_diaadd
-      NAMELIST/natdia/nwritedia, diag3d, diag2d     ! additional diagnostics
-#endif
       !!---------------------------------------------------------------------
 
@@ -99,5 +85,6 @@
       ! Namelist nattrc (files)
       ! ----------------------------------------------
-      nwritetrc = 10                 ! default values
+      ndttrc    = 1                 ! default values
+      nwritetrc = 10      
       lrsttr    = .FALSE.
       nrsttr    =  0
@@ -111,5 +98,8 @@
 
       REWIND( numnat )               ! read nattrc
-      READ  ( numnat, nattrc )
+      READ  ( numnat, namtoptrc )
+
+      !!Chris  computes the first time step of tracer model
+      nittrc000 = nit000 + ndttrc - 1
 
       DO jn = 1, jptra
@@ -122,11 +112,12 @@
 
 
-
       IF(lwp) THEN                   ! control print
          WRITE(numout,*)
-         WRITE(numout,*) ' Namelist : nattrc'
+         WRITE(numout,*) ' Namelist : namtoptrc'
+         WRITE(numout,*) '    time step freq. for pass. trac. ndttrc             = ', ndttrc
+         WRITE(numout,*) '    1st time step for pass. trac. nittrc000            = ', nittrc000
          WRITE(numout,*) '    frequency of outputs for passive tracers nwritetrc = ', nwritetrc  
-         WRITE(numout,*) '    restart LOGICAL for passive tr. lrsttr = ', lrsttr
-         WRITE(numout,*) '    control of time step for p. tr. nrsttr = ', nrsttr
+         WRITE(numout,*) '    restart LOGICAL for passive tr. lrsttr             = ', lrsttr
+         WRITE(numout,*) '    control of time step for p. tr. nrsttr             = ', nrsttr
          DO jn = 1, jptra
             WRITE(numout,*) '   tracer nb             : ', jn 
@@ -150,5 +141,5 @@
 
       REWIND( numnat )               ! read natrtd
-      READ  ( numnat, natrtd )
+      READ  ( numnat, namtoptrd )
 
       nkeep=0
@@ -167,5 +158,5 @@
       IF(lwp) THEN                   ! control print
          WRITE(numout,*)
-         WRITE(numout,*) ' Namelist : natrtd'
+         WRITE(numout,*) ' Namelist : namtoptrd'
          WRITE(numout,*) '    frequency of outputs for dynamical trends nwritetrd = ', nwritetrd
          DO jn = 1, jptra
@@ -177,84 +168,4 @@
 #endif
 
-#if defined key_trc_diaadd
-
-      ! Namelist natrtd (transport trends)
-      ! ----------------------------------------------
-      nwritedia = 10                 ! default values 
-      !                                 ! 2D output arrays
-      DO jn = 1, jpdia2d
-         WRITE(ctrc2d(jn),'("2D_",I1)') jn                      ! short name
-         WRITE(ctrc2l(jn),'("2D DIAGNOSTIC NUMBER ",I2)') jn    ! long name
-         ctrc2u(jn) = ' '                                       ! units 
-      END DO
-      !                                 ! 3D output arrays
-      DO jn = 1, jpdia3d
-         WRITE(ctrc3d(jn),'("3D_",I1)') jn                     ! short name
-         WRITE(ctrc3l(jn),'("3D DIAGNOSTIC NUMBER ",I2)') jn    ! long name
-         ctrc3u(jn) = ' '                                       ! units
-      END DO
-
-      REWIND( numnat )               ! read natrtd
-      READ  ( numnat, natdia )
-
-      DO jn = 1, jpdia2d
-         ctrc2d(jn) = diag2d(jn)%snamedia
-         ctrc2l(jn) = diag2d(jn)%lnamedia
-         ctrc2u(jn) = diag2d(jn)%unitdia
-      END DO
-
-      DO jn = 1, jpdia3d
-         ctrc3d(jn) = diag3d(jn)%snamedia
-         ctrc3l(jn) = diag3d(jn)%lnamedia
-         ctrc3u(jn) = diag3d(jn)%unitdia
-      END DO
-
-      IF(lwp) THEN                   ! control print
-         WRITE(numout,*)
-         WRITE(numout,*) ' Namelist : natadd'
-         WRITE(numout,*) '    frequency of outputs for additional arrays nwritedia = ', nwritedia
-         DO jn = 1, jpdia3d
-            WRITE(numout,*) '   3d output field No : ',jn
-            WRITE(numout,*) '   short name         : ', TRIM(ctrc3d(jn))
-            WRITE(numout,*) '   long name          : ', TRIM(ctrc3l(jn))
-            WRITE(numout,*) '   unit               : ', TRIM(ctrc3u(jn))
-            WRITE(numout,*) ' '
-         END DO
-
-         DO jn = 1, jpdia2d
-            WRITE(numout,*) '   2d output field No : ',jn
-            WRITE(numout,*) '   short name         : ', TRIM(ctrc2d(jn))
-            WRITE(numout,*) '   long name          : ', TRIM(ctrc2l(jn))
-            WRITE(numout,*) '   unit               : ', TRIM(ctrc2u(jn))
-            WRITE(numout,*) ' '
-         END DO
-      ENDIF
-#endif
-
-      !! Namelist natnum :
-      !! -----------------
-      rsc      = 1.                 ! default values
-      rtrn     = 1.e-15
-      ncortrc  = 1
-      ndttrc   = 4
-      crosster = .FALSE.
-
-      REWIND( numnat )              ! read natnum
-      READ  ( numnat, natnum )
-
-      !!Chris  computes the first time step of tracer model
-      nittrc000 = nit000 + ndttrc - 1
-
-      IF(lwp) THEN                  ! control print
-         WRITE(numout,*)
-         WRITE(numout,*) ' Namelist : natnum'
-         WRITE(numout,*)
-         WRITE(numout,*) ' tuning coefficient              rsc     = ', rsc
-         WRITE(numout,*) ' truncation value                rtrn    = ', rtrn
-         WRITE(numout,*) ' number of corrective phase      ncortrc = ', ncortrc
-         WRITE(numout,*) ' time step freq. for pass. trac. ndttrc  = ', ndttrc
-         WRITE(numout,*) ' 1st time step for pass. trac. nittrc000 = ', nittrc000
-         WRITE(numout,*) ' computes or not crossterms    crosster  = ', crosster
-      ENDIF
 
       ! namelist of transport
